searchData={"items":[{"type":"task","title":"mix download.dictionaries","doc":"Downloads the ICU (Unicode) utilities supporting word breaks\nfor Chinese, Japanese, Thai, Burmese and Laotion languages.","ref":"Mix.Tasks.Download.Dictionaries.html"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.certificate_locations/0","doc":"","ref":"Mix.Tasks.Download.Dictionaries.html#certificate_locations/0"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.data_path/1","doc":"","ref":"Mix.Tasks.Download.Dictionaries.html#data_path/1"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.get/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get/2"},{"type":"function","title":"Arguments - Mix.Tasks.Download.Dictionaries.get/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get/2-arguments"},{"type":"function","title":"Options - Mix.Tasks.Download.Dictionaries.get/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get/2-options"},{"type":"function","title":"Returns - Mix.Tasks.Download.Dictionaries.get/2","doc":"* `{:ok, body}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get/2-returns"},{"type":"function","title":"Unsafe HTTPS - Mix.Tasks.Download.Dictionaries.get/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get/2-unsafe-https"},{"type":"function","title":"Certificate stores - Mix.Tasks.Download.Dictionaries.get/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"Mix.Tasks.Download.Dictionaries.html#get/2-certificate-stores"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2"},{"type":"function","title":"Arguments - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-arguments"},{"type":"function","title":"Options - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.\n\n* `:https_proxy` is the URL of an https proxy to be used. The\n  default is `nil`.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-options"},{"type":"function","title":"Returns - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"* `{:ok, body, headers}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-returns"},{"type":"function","title":"Unsafe HTTPS - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-unsafe-https"},{"type":"function","title":"Https Proxy - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"`Cldr.Http.get/2` will look for a proxy URL in the following\nlocales in the order presented:\n\n* `options[:https_proxy]`\n* `ex_cldr` compile-time configuration under the\n  key `:ex_cldr[:https_proxy]`\n* The environment variable `HTTPS_PROXY`\n* The environment variable `https_proxy`\n\n#","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-https-proxy"},{"type":"function","title":"Certificate stores - Mix.Tasks.Download.Dictionaries.get_with_headers/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"Mix.Tasks.Download.Dictionaries.html#get_with_headers/2-certificate-stores"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.otp_version/0","doc":"","ref":"Mix.Tasks.Download.Dictionaries.html#otp_version/0"},{"type":"function","title":"Mix.Tasks.Download.Dictionaries.root_url/0","doc":"","ref":"Mix.Tasks.Download.Dictionaries.html#root_url/0"},{"type":"module","title":"Unicode.String","doc":"This module provides functions that implement some\nof the [Unicode](https://unicode.org) standards:\n\n* The [Unicode Case Mapping](https://www.unicode.org/versions/Unicode13.0.0/ch03.pdf) algorithm\n  to provide mapping to upper, lower and title case text.\n\n* The [Unicode Case Folding](https://www.unicode.org/versions/Unicode13.0.0/ch03.pdf) algorithm\n  to provide case-independent equality checking irrespective of language or script.\n\n* The [Unicode Segmentation](https://unicode.org/reports/tr29/) algorithm to detect,\n  break or splut strings into grapheme clusters, works and sentences.\n\n* The [Unicode Line Breaking](https://www.unicode.org/reports/tr14/) algorithm to determine\n  line breaks (as in word-wrapping).\n\n* The [Unicode Case Mapping](https://www.unicode.org/versions/Unicode13.0.0/ch03.pdf) algorithm\n  to provide mapping to upper, lower and title case text.","ref":"Unicode.String.html"},{"type":"function","title":"Unicode.String.break/2","doc":"Returns match data indicating if the\nrequested break is applicable\nat the point between the two string\nsegments represented by `{string_before, string_after}`.","ref":"Unicode.String.html#break/2"},{"type":"function","title":"Arguments - Unicode.String.break/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#break/2-arguments"},{"type":"function","title":"Returns - Unicode.String.break/2","doc":"A tuple indicating if a break would\nbe applicable at this point between\n`string_before` and `string_after`.\n\n* `{:break, {string_before, {matched_string, remaining_string}}}` or\n\n* `{:no_break, {string_before, {matched_string, remaining_string}}}` or\n\n* `{:error, reason}`","ref":"Unicode.String.html#break/2-returns"},{"type":"function","title":"Options - Unicode.String.break/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0`.\n  The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.","ref":"Unicode.String.html#break/2-options"},{"type":"function","title":"Examples - Unicode.String.break/2","doc":"iex> Unicode.String.break {\"This is \", \"some words\"}\n    {:break, {\"This is \", {\"s\", \"ome words\"}}}\n\n    iex> Unicode.String.break {\"This is \", \"some words\"}, break: :sentence\n    {:no_break, {\"This is \", {\"s\", \"ome words\"}}}\n\n    iex> Unicode.String.break {\"This is one. \", \"This is some words.\"}, break: :sentence\n    {:break, {\"This is one. \", {\"T\", \"his is some words.\"}}}","ref":"Unicode.String.html#break/2-examples"},{"type":"function","title":"Unicode.String.break?/2","doc":"Returns a boolean indicating if the\nrequested break is applicable\nat the point between the two string\nsegments represented by `{string_before, string_after}`.","ref":"Unicode.String.html#break?/2"},{"type":"function","title":"Arguments - Unicode.String.break?/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#break?/2-arguments"},{"type":"function","title":"Returns - Unicode.String.break?/2","doc":"* `true` or `false` or\n\n* raises an exception if there is an error","ref":"Unicode.String.html#break?/2-returns"},{"type":"function","title":"Options - Unicode.String.break?/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0`.\n  The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.","ref":"Unicode.String.html#break?/2-options"},{"type":"function","title":"Examples - Unicode.String.break?/2","doc":"iex> Unicode.String.break? {\"This is \", \"some words\"}\n    true\n\n    iex> Unicode.String.break? {\"This is \", \"some words\"}, break: :sentence\n    false\n\n    iex> Unicode.String.break? {\"This is one. \", \"This is some words.\"}, break: :sentence\n    true","ref":"Unicode.String.html#break?/2-examples"},{"type":"function","title":"Unicode.String.downcase/2","doc":"Converts all characters in the given string to lower case\naccording to the Unicode Casing algorithm.\n\n#","ref":"Unicode.String.html#downcase/2"},{"type":"function","title":"Arguments - Unicode.String.downcase/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of options.\n\n#","ref":"Unicode.String.html#downcase/2-arguments"},{"type":"function","title":"Options - Unicode.String.downcase/2","doc":"* `:locale` is any [ISO 639](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes)\n  language code or a [LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  which provides integration with [ex_cldr](https://hex.pm/packages/ex_cldr)\n  applications.  The default is `:any` which signifies the\n  application of the base Unicode casing algorithm.\n\n#","ref":"Unicode.String.html#downcase/2-options"},{"type":"function","title":"Notes - Unicode.String.downcase/2","doc":"* The locale option determines the use of certain locale-specific\n  casing rules.  Where no specific casing rules apply to\n  the given locale, the base Unicode casing algorithm is\n  applied. The locales which have customized casing rules\n  are returned by `Unicode.String.special_casing_locales/0`.\n\n#","ref":"Unicode.String.html#downcase/2-notes"},{"type":"function","title":"Returns - Unicode.String.downcase/2","doc":"* `downcased_string`\n\n#","ref":"Unicode.String.html#downcase/2-returns"},{"type":"function","title":"Examples - Unicode.String.downcase/2","doc":"iex> Unicode.String.downcase(\"THE QUICK BROWN FOX\")\n    \"the quick brown fox\"\n\n    # Lower case Greek with a final sigma\n    iex> Unicode.String.downcase(\"ὈΔΥΣΣΕΎΣ\", locale: :el)\n    \"ὀδυσσεύς\"\n\n    # Lower case in Turkish and Azeri correctly handles\n    # undotted-i and undotted-I\n    iex> Unicode.String.downcase(\"DİYARBAKIR\", locale: :tr)\n    \"diyarbakır\"","ref":"Unicode.String.html#downcase/2-examples"},{"type":"function","title":"Unicode.String.equals_ignoring_case?/3","doc":"Compares two strings in a case insensitive\nmanner.\n\nCase folding is applied to the two string\narguments which are then compared with the\n`==` operator.","ref":"Unicode.String.html#equals_ignoring_case?/3"},{"type":"function","title":"Arguments - Unicode.String.equals_ignoring_case?/3","doc":"* `string_a` and `string_b` are two strings\n  to be compared","ref":"Unicode.String.html#equals_ignoring_case?/3-arguments"},{"type":"function","title":"Returns - Unicode.String.equals_ignoring_case?/3","doc":"* `true` or `false`","ref":"Unicode.String.html#equals_ignoring_case?/3-returns"},{"type":"function","title":"Notes - Unicode.String.equals_ignoring_case?/3","doc":"* This function applies the [Unicode Case Folding\n  algorithm](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf)\n\n* The algorithm does not apply any treatment to diacritical\n  marks hence \"compare strings without accents\" is not\n  part of this function.\n\n* No string normalization is performed. Where the\n  normalization state of the string cannot be guaranteed\n  it is recommended they be normalized before comparison\n  using `String.normalize(string, :nfc)`.","ref":"Unicode.String.html#equals_ignoring_case?/3-notes"},{"type":"function","title":"Examples - Unicode.String.equals_ignoring_case?/3","doc":"iex> Unicode.String.equals_ignoring_case? \"ABC\", \"abc\"\n    true\n\n    iex> Unicode.String.equals_ignoring_case? \"beißen\", \"beissen\"\n    true\n\n    iex> Unicode.String.equals_ignoring_case? \"grüßen\", \"grussen\"\n    false","ref":"Unicode.String.html#equals_ignoring_case?/3-examples"},{"type":"function","title":"Unicode.String.find_matching_locale/3","doc":"","ref":"Unicode.String.html#find_matching_locale/3"},{"type":"function","title":"Unicode.String.fold/1","doc":"","ref":"Unicode.String.html#fold/1"},{"type":"function","title":"Unicode.String.fold/2","doc":"","ref":"Unicode.String.html#fold/2"},{"type":"function","title":"Unicode.String.next/2","doc":"Returns next segment in a string.","ref":"Unicode.String.html#next/2"},{"type":"function","title":"Arguments - Unicode.String.next/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#next/2-arguments"},{"type":"function","title":"Returns - Unicode.String.next/2","doc":"A tuple with the segment and the remainder of the string or `\"\"`\nin case the String reached its end.\n\n* `{next_string, rest_of_the_string}` or\n\n* `{:error, reason}`","ref":"Unicode.String.html#next/2-returns"},{"type":"function","title":"Options - Unicode.String.next/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0` or\n  a [Cldr.LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  struct. The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.","ref":"Unicode.String.html#next/2-options"},{"type":"function","title":"Examples - Unicode.String.next/2","doc":"iex> Unicode.String.next \"This is a sentence. And another.\", break: :word\n    {\"This\", \" is a sentence. And another.\"}\n\n    iex> Unicode.String.next \"This is a sentence. And another.\", break: :sentence\n    {\"This is a sentence. \", \"And another.\"}","ref":"Unicode.String.html#next/2-examples"},{"type":"function","title":"Unicode.String.special_casing_locales/0","doc":"Returms a list of locales that have special\ncasing rules.\n\n#","ref":"Unicode.String.html#special_casing_locales/0"},{"type":"function","title":"Example - Unicode.String.special_casing_locales/0","doc":"iex> Unicode.String.special_casing_locales()\n    [:az, :el, :lt, :nl, :tr]","ref":"Unicode.String.html#special_casing_locales/0-example"},{"type":"function","title":"Unicode.String.split/2","doc":"Splits a string according to the\nspecified break type.","ref":"Unicode.String.html#split/2"},{"type":"function","title":"Arguments - Unicode.String.split/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#split/2-arguments"},{"type":"function","title":"Returns - Unicode.String.split/2","doc":"* A list of strings after applying the\n  specified break rules or\n\n* `{:error, reason}`","ref":"Unicode.String.html#split/2-returns"},{"type":"function","title":"Options - Unicode.String.split/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0` or\n  a [Cldr.LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  struct. The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.\n\n* `:trim` is a boolean indicating if segments\n  the are comprised of only white space are to be\n  excluded from the returned list.  The default\n  is `false`.","ref":"Unicode.String.html#split/2-options"},{"type":"function","title":"Examples - Unicode.String.split/2","doc":"iex> Unicode.String.split \"This is a sentence. And another.\", break: :word\n    [\"This\", \" \", \"is\", \" \", \"a\", \" \", \"sentence\", \".\", \" \", \"And\", \" \", \"another\", \".\"]\n\n    iex> Unicode.String.split \"This is a sentence. And another.\", break: :word, trim: true\n    [\"This\", \"is\", \"a\", \"sentence\", \".\", \"And\", \"another\", \".\"]\n\n    iex> Unicode.String.split \"This is a sentence. And another.\", break: :sentence\n    [\"This is a sentence. \", \"And another.\"]","ref":"Unicode.String.html#split/2-examples"},{"type":"function","title":"Unicode.String.splitter/2","doc":"Returns an enumerable that splits a string on demand.","ref":"Unicode.String.html#splitter/2"},{"type":"function","title":"Arguments - Unicode.String.splitter/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#splitter/2-arguments"},{"type":"function","title":"Returns - Unicode.String.splitter/2","doc":"* A function that implements the enumerable\n  protocol or\n\n* `{:error, reason}`","ref":"Unicode.String.html#splitter/2-returns"},{"type":"function","title":"Options - Unicode.String.splitter/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0`.\n  The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.\n\n* `:trim` is a boolean indicating if segments\n  the are comprised of only white space are to be\n  excluded from the returned list.  The default\n  is `false`.","ref":"Unicode.String.html#splitter/2-options"},{"type":"function","title":"Examples - Unicode.String.splitter/2","doc":"iex> enum = Unicode.String.splitter \"This is a sentence. And another.\", break: :word, trim: true\n    iex> Enum.take enum, 3\n    [\"This\", \"is\", \"a\"]","ref":"Unicode.String.html#splitter/2-examples"},{"type":"function","title":"Unicode.String.stream/2","doc":"Return a stream that breaks a string into\ngraphemes, words, sentences or line breaks.","ref":"Unicode.String.html#stream/2"},{"type":"function","title":"Arguments - Unicode.String.stream/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of\n  options.","ref":"Unicode.String.html#stream/2-arguments"},{"type":"function","title":"Returns - Unicode.String.stream/2","doc":"* A stream that is an `t:Enumerable.t/0` that\n  can be used with the functions in the `Stream`\n  or `Enum` modules.\n\n* `{:error, reason}`","ref":"Unicode.String.html#stream/2-returns"},{"type":"function","title":"Options - Unicode.String.stream/2","doc":"* `:locale` is any locale returned by\n  `Unicode.String.Segment.known_segmentation_locales/0` or\n  a [Cldr.LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  struct. The default is \"root\" which corresponds\n  to the break rules defined by the\n  [Unicode Segmentation](https://unicode.org/reports/tr29/) rules.\n\n* `:break` is the type of break. It is one of\n  `:grapheme`, `:word`, `:line` or `:sentence`. The\n  default is `:word`.\n\n* `:suppressions` is a boolean which,\n  if `true`, will suppress breaks for common\n  abbreviations defined for the `locale`. The\n  default is `true`.\n\n* `:trim` is a boolean indicating if segments\n  the are comprised of only white space are to be\n  excluded from the returned list.  The default\n  is `false`.","ref":"Unicode.String.html#stream/2-options"},{"type":"function","title":"Examples - Unicode.String.stream/2","doc":"iex> Enum.to_list Unicode.String.stream(\"this is a set of words\", trim: true)\n  [\"this\", \"is\", \"a\", \"set\", \"of\", \"words\"]\n\n  iex> Enum.to_list Unicode.String.stream(\"this is a set of words\", break: :sentence, trim: true)\n  [\"this is a set of words\"]","ref":"Unicode.String.html#stream/2-examples"},{"type":"function","title":"Unicode.String.titlecase/2","doc":"Converts the given string to title case\naccording to the Unicode Casing algorithm.\n\nTitle casing is the process of transforming\nthe first character of each word in a string\nto upper case and the following characters\nin the word to lower case.\n\nAs a result this algorithm does not conform\nto the norms of all languages and cultures.\nHowever special processing is performed for\nthe Dutch dipthong \"IJ\" when using the `:nl`\ncasing locale.\n\nFurther work will focus on improving title\ncasing of Greek dipthongs.\n\n#","ref":"Unicode.String.html#titlecase/2"},{"type":"function","title":"Arguments - Unicode.String.titlecase/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of options.\n\n#","ref":"Unicode.String.html#titlecase/2-arguments"},{"type":"function","title":"Options - Unicode.String.titlecase/2","doc":"* `:locale` is any [ISO 639](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes)\n  language code or a [LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  which provides integration with [ex_cldr](https://hex.pm/packages/ex_cldr)\n  applications.  The default is `:any` which signifies the\n  application of the base Unicode casing algorithm.\n\n#","ref":"Unicode.String.html#titlecase/2-options"},{"type":"function","title":"Notes - Unicode.String.titlecase/2","doc":"* The locale option determines the use of certain locale-specific\n  casing rules.  Where no specific casing rules apply to\n  the given locale, the base Unicode casing algorithm is\n  applied. The locales which have customized casing rules\n  are returned by `Unicode.String.special_casing_locales/0`.\n\n* The string is broken into words using\n  `Unicode.String.break/2` which implements the\n  [Unicode segmentation algorithm](https://unicode.org/reports/tr29/).\n\n#","ref":"Unicode.String.html#titlecase/2-notes"},{"type":"function","title":"Returns - Unicode.String.titlecase/2","doc":"* `title_cased_string`.\n\n#","ref":"Unicode.String.html#titlecase/2-returns"},{"type":"function","title":"Examples - Unicode.String.titlecase/2","doc":"iex> Unicode.String.titlecase(\"THE QUICK BROWN FOX\")\n    \"The Quick Brown Fox\"\n\n    # Title case Dutch with leading dipthong\n    iex> Unicode.String.titlecase(\"ijsselmeer\", locale: :nl)\n    \"IJsselmeer\"","ref":"Unicode.String.html#titlecase/2-examples"},{"type":"function","title":"Unicode.String.upcase/2","doc":"Converts all characters in the given string to upper case\naccording to the Unicode Casing algorithm.\n\n#","ref":"Unicode.String.html#upcase/2"},{"type":"function","title":"Arguments - Unicode.String.upcase/2","doc":"* `string` is any `t:String.t/0`.\n\n* `options` is a keyword list of options.\n\n#","ref":"Unicode.String.html#upcase/2-arguments"},{"type":"function","title":"Options - Unicode.String.upcase/2","doc":"* `:locale` is any [ISO 639](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes)\n  language code or a [LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html)\n  which provides integration with [ex_cldr](https://hex.pm/packages/ex_cldr)\n  applications.  The default is `:any` which signifies the\n  application of the base Unicode casing algorithm.\n\n#","ref":"Unicode.String.html#upcase/2-options"},{"type":"function","title":"Notes - Unicode.String.upcase/2","doc":"* The locale option determines the use of certain locale-specific\n  casing rules.  Where no specific casing rules apply to\n  the given locale, the base Unicode casing algorithm is\n  applied. The locales which have customized casing rules\n  are returned by `Unicode.String.special_casing_locales/0`.\n\n#","ref":"Unicode.String.html#upcase/2-notes"},{"type":"function","title":"Returns - Unicode.String.upcase/2","doc":"* `downcased_string`\n\n#","ref":"Unicode.String.html#upcase/2-returns"},{"type":"function","title":"Examples - Unicode.String.upcase/2","doc":"# Basic case transformation\n    iex> Unicode.String.upcase(\"the quick brown fox\")\n    \"THE QUICK BROWN FOX\"\n\n    # Dotted-I in Turkish and Azeri\n    iex> Unicode.String.upcase(\"Diyarbakır\", locale: :tr)\n    \"DİYARBAKIR\"\n\n    # Upper case in Greek removes diacritics\n    iex> Unicode.String.upcase(\"Πατάτα, Αέρας, Μυστήριο\", locale: :el)\n    \"ΠΑΤΑΤΑ, ΑΕΡΑΣ, ΜΥΣΤΗΡΙΟ\"","ref":"Unicode.String.html#upcase/2-examples"},{"type":"type","title":"Unicode.String.break_match/0","doc":"","ref":"Unicode.String.html#t:break_match/0"},{"type":"type","title":"Unicode.String.break_or_no_break/0","doc":"","ref":"Unicode.String.html#t:break_or_no_break/0"},{"type":"type","title":"Unicode.String.break_type/0","doc":"","ref":"Unicode.String.html#t:break_type/0"},{"type":"type","title":"Unicode.String.error_return/0","doc":"","ref":"Unicode.String.html#t:error_return/0"},{"type":"type","title":"Unicode.String.mode_or_language/0","doc":"","ref":"Unicode.String.html#t:mode_or_language/0"},{"type":"type","title":"Unicode.String.options/0","doc":"","ref":"Unicode.String.html#t:options/0"},{"type":"type","title":"Unicode.String.split_options/0","doc":"","ref":"Unicode.String.html#t:split_options/0"},{"type":"type","title":"Unicode.String.string_interval/0","doc":"","ref":"Unicode.String.html#t:string_interval/0"},{"type":"module","title":"Unicode.String.Break","doc":"Implements the Unicode break algorithm","ref":"Unicode.String.Break.html"},{"type":"module","title":"Unicode.String.Case.Folding","doc":"Implements the Unicode Case Folding algorithm.\n\nThe intention of case folding is to facilitate\ncase-insensitive string comparisons. It is not\nintended to be a general purpose transformation.\n\nAlthough case folding does generally use lower\ncase as its normal form, it is not true for\nall scripts and codepoints.  Therefore case\nfolding should not be used as an alternative\nto `String.downcase/1`.","ref":"Unicode.String.Case.Folding.html"},{"type":"function","title":"Unicode.String.Case.Folding.fold/1","doc":"Case fold a string.\n\nReturns a string after applying the Unicode\nCase Folding algorithm.\n\nCase folding is intended to suport case\ninsensitve string comparisons such as that\nimplemented by `Unicode.String.equals_ignoring_case?/2` which\ncalls this function on its parameters.\n\n#","ref":"Unicode.String.Case.Folding.html#fold/1"},{"type":"function","title":"Arguments - Unicode.String.Case.Folding.fold/1","doc":"* `string` is any `String.t()`\n\n* `mode or language tag` is either the atoms `:turkic` or `nil`\n  or a map that includes the key `:language` with a value that\n  is a lowercase atom representing an [ISO 639-1](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes)\n  language code. The [CLDR language tag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html) which is defined\n  as part of the [ex_cldr](https://hex.pm/packages/ex_cldr) is one\n  such example. See [Cldr.validate_locale/2](https://hexdocs.pm/ex_cldr/Cldr.html#validate_locale/2)\n  for further information. The default is `nil`.\n\n#","ref":"Unicode.String.Case.Folding.html#fold/1-arguments"},{"type":"function","title":"Returns - Unicode.String.Case.Folding.fold/1","doc":"* The case folded string\n\n#","ref":"Unicode.String.Case.Folding.html#fold/1-returns"},{"type":"function","title":"Notes - Unicode.String.Case.Folding.fold/1","doc":"* No normalization is applied to the\n  string on either input or output.\n\n* Case folding does not apply any transformation\n  to accented characters. `\"ü\"` will not case fold\n  to `\"u\"` for example.\n\n#","ref":"Unicode.String.Case.Folding.html#fold/1-notes"},{"type":"function","title":"Examples - Unicode.String.Case.Folding.fold/1","doc":"iex> Unicode.String.Case.Folding.fold(\"THIS\")\n    \"this\"\n\n    iex> Unicode.String.Case.Folding.fold(\"grüßen\")\n    \"grüssen\"\n\n    iex(13)> Unicode.String.Case.Folding.fold(\"I\")\n    \"i\"\n\n    # Turkic languages such as Turkish and Azerbaijani have\n    # a dotless lower case \"i\"\n    iex> Unicode.String.Case.Folding.fold(\"I\", :turkic)\n    \"ı\"\n\n    iex> Unicode.String.Case.Folding.fold(\"I\", %{language: :az})\n    \"ı\"","ref":"Unicode.String.Case.Folding.html#fold/1-examples"},{"type":"function","title":"Unicode.String.Case.Folding.fold/2","doc":"","ref":"Unicode.String.Case.Folding.html#fold/2"},{"type":"module","title":"Unicode.String.Case.Mapping","doc":"The [Unicode Case Mapping](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) algorithm\ndefines the process and data to transform text into upper case, lower case or title case.\n\nSince most languages are not bicameral, characters which have no appropriate mapping remain unchanged.\n\nThree case mapping functions are provided as a public API which have their implementations in this module:\n\n* `Unicode.String.upcase/2` which will convert text to upper case characters.\n* `Unicode.String.downcase/2` which will convert text to lower case characters.\n* `Unicode.String.titlecase/2` which will convert text to title case.  Title case means\n  that the first character or each word is set to upper case and all other characters in\n  the word are set to lower case. `Unicode.String.split/2` is used to split the string\n  into words before title casing.\n\nEach function operates in a locale-aware manner implementing some basic capabilities:\n\n* Casing rules for the Turkish dotted capital `I` and dotless small `i`.\n* Casing rules for the retention of dots over `i` for Lithuanian letters with additional accents.\n* Titlecasing of IJ at the start of words in Dutch.\n* Removal of accents when upper casing letters in Greek.\n\nThere are other casing rules that are not currently implemented such as:\n\n* Titlecasing of second or subsequent letters in words in orthographies that include\n  caseless letters such as apostrophes.\n* Uppercasing of U+00DF `ß` latin small letter sharp `s` to U+1E9E `ẞ` latin capital letter\n  sharp `s`.\n\n#","ref":"Unicode.String.Case.Mapping.html"},{"type":"module","title":"Examples - Unicode.String.Case.Mapping","doc":"# Basic case transformation\n    iex> Unicode.String.Case.Mapping.upcase(\"the quick brown fox\")\n    \"THE QUICK BROWN FOX\"\n\n    # Dotted-I in Turkish and Azeri\n    iex> Unicode.String.Case.Mapping.upcase(\"Diyarbakır\", :tr)\n    \"DİYARBAKIR\"\n\n    # Upper case in Greek removes diacritics\n    iex> Unicode.String.Case.Mapping.upcase(\"Πατάτα, Αέρας, Μυστήριο\", :el)\n    \"ΠΑΤΑΤΑ, ΑΕΡΑΣ, ΜΥΣΤΗΡΙΟ\"\n\n    # Lower case Greek with a final sigma\n    iex> Unicode.String.Case.Mapping.downcase(\"ὈΔΥΣΣΕΎΣ\", :el)\n    \"ὀδυσσεύς\"\n\n    # Title case Dutch with leading dipthong\n    iex> Unicode.String.Case.Mapping.titlecase(\"ijsselmeer\", :nl)\n    \"IJsselmeer\"","ref":"Unicode.String.Case.Mapping.html#module-examples"},{"type":"function","title":"Unicode.String.Case.Mapping.downcase/2","doc":"Replace upper case characters with their\nlower case equivalents.","ref":"Unicode.String.Case.Mapping.html#downcase/2"},{"type":"function","title":"Unicode.String.Case.Mapping.titlecase/2","doc":"Apply to Unicode title case algorithm.","ref":"Unicode.String.Case.Mapping.html#titlecase/2"},{"type":"function","title":"Unicode.String.Case.Mapping.upcase/2","doc":"Replace lower case characters with their\nuppercase equivalents.\n\nLower case characters are replaced with their\nupper case equivalents. All other characters\nremain unchanged.\n\nFor the Greek language (`:el`), all accents are\nremoved prior to capitalization as is the normal\npractise for this language.","ref":"Unicode.String.Case.Mapping.html#upcase/2"},{"type":"module","title":"Unicode.String.Case.Mapping.Greek","doc":"Implements the special upper casing rules for\nfor the Greek language.","ref":"Unicode.String.Case.Mapping.Greek.html"},{"type":"function","title":"Unicode.String.Case.Mapping.Greek.upcase/1","doc":"This implementation currently implements the `el-Upper` transform\nfrom CLDR.\n\n#","ref":"Unicode.String.Case.Mapping.Greek.html#upcase/1"},{"type":"function","title":"CLDR algorithm - Unicode.String.Case.Mapping.Greek.upcase/1","doc":"According to CLDR all accents on all characters are are omitted when\nupcasing.\n\n  Remove 0301 following Greek, with possible intervening 0308 marks.\n  ::NFD();\n  For uppercasing (not titlecasing!) remove all greek accents from greek letters.\n  This is done in two groups, to account for canonical ordering.\n  [:Greek:] [^[:ccc=Not_Reordered:][:ccc=Above:]]*? { [̓̔́̀̆͂̈̄] → ;\n  [:Greek:] [^[:ccc=Not_Reordered:][:ccc=Iota_Subscript:]]*? { ͅ → ;\n  ::NFC();\n\nThat transform basically says remove all accents except a\nsubscripted iota. It doesn't handle dipthongs correctly.\n\n#","ref":"Unicode.String.Case.Mapping.Greek.html#upcase/1-cldr-algorithm"},{"type":"function","title":"Mozilla algorithm - Unicode.String.Case.Mapping.Greek.upcase/1","doc":"Mozilla has a thread on a [bug report](https://bugzilla.mozilla.org/show_bug.cgi?id=307039)\nthat:\n\n>  Greek accented letters should be converted to the respective non-accented uppercase\n>  letters. The required conversions are the following (in Unicode):\n>\n>  ά -> Α\n>  έ -> Ε\n>  ή -> Η\n>  ί -> Ι\n>  ΐ -> Ϊ\n>  ό -> Ο\n>  ύ -> Υ\n>  ΰ -> Ϋ\n>  ώ -> Ω\n>\n>  Also diphthongs (two-vowel constructs) should be converted as follows, when the\n>  first vowel is accented:\n>\n>  άι -> ΑΪ\n>  έι -> ΕΪ\n>  όι -> ΟΪ\n>  ύι -> ΥΪ\n>  άυ -> ΑΫ\n>  έυ -> ΕΫ\n>  ήυ -> ΗΫ\n>  όυ -> ΟΫ\n\nThat thread seems to align with current-day [Mozilla](https://developer.mozilla.org/en-US/docs/Web/CSS/text-transform)\nwhich says the rules are:\n\n> In Greek (el), vowels lose their accent when the whole word is in\n> uppercase (ά/Α), except for the disjunctive eta (ή/Ή). Also, diphthongs\n> with an accent on the first vowel lose the accent and gain a diaeresis\n> on the second vowel (άι/ΑΪ).","ref":"Unicode.String.Case.Mapping.Greek.html#upcase/1-mozilla-algorithm"},{"type":"module","title":"Unicode.String.Segment","doc":"Implements the compilation of the Unicode\nsegment rules.","ref":"Unicode.String.Segment.html"},{"type":"function","title":"Unicode.String.Segment.ancestors/1","doc":"Returns a list of the ancestor locales\nof the a given locale.\n\nThe list includes the given locale.","ref":"Unicode.String.Segment.html#ancestors/1"},{"type":"function","title":"Unicode.String.Segment.compile_rule/3","doc":"Compiles a segment rule in the context of a list\nof variables.\n\nThe compile rule can then be inserted into a\nrule set.","ref":"Unicode.String.Segment.html#compile_rule/3"},{"type":"function","title":"Unicode.String.Segment.compile_rules/3","doc":"","ref":"Unicode.String.Segment.html#compile_rules/3"},{"type":"function","title":"Unicode.String.Segment.evaluate_rules/2","doc":"Evaluates a list of rules against a given\nstring.","ref":"Unicode.String.Segment.html#evaluate_rules/2"},{"type":"function","title":"Unicode.String.Segment.expand_variables/2","doc":"","ref":"Unicode.String.Segment.html#expand_variables/2"},{"type":"macro","title":"Unicode.String.Segment.is_id_continue/1","doc":"Identifies if a codepoint is a valid identifier character","ref":"Unicode.String.Segment.html#is_id_continue/1"},{"type":"macro","title":"Unicode.String.Segment.is_id_start/1","doc":"Identifies if a codepoint is a valid start of an identifier","ref":"Unicode.String.Segment.html#is_id_start/1"},{"type":"function","title":"Unicode.String.Segment.known_segmentation_locales/0","doc":"Returns a list of the known locales that have\nsegmentation data.","ref":"Unicode.String.Segment.html#known_segmentation_locales/0"},{"type":"function","title":"Unicode.String.Segment.maybe_log_rule/5","doc":"","ref":"Unicode.String.Segment.html#maybe_log_rule/5"},{"type":"function","title":"Unicode.String.Segment.rules/3","doc":"Return the rules as defined by CLDR for a given\nlocale and break type.","ref":"Unicode.String.Segment.html#rules/3"},{"type":"function","title":"Unicode.String.Segment.rules!/3","doc":"Return the rules as defined by CLDR for a given\nlocale and break type and raises on error.","ref":"Unicode.String.Segment.html#rules!/3"},{"type":"function","title":"Unicode.String.Segment.suppressions/2","doc":"Returns a list of the suppressions for a given\nlocale and segment type.","ref":"Unicode.String.Segment.html#suppressions/2"},{"type":"function","title":"Unicode.String.Segment.suppressions!/2","doc":"Returns a list of the suppressions for a given\nlocale and segment type and raises on error.","ref":"Unicode.String.Segment.html#suppressions!/2"},{"type":"extras","title":"Unicode String","doc":"# Unicode String\n\n![Build status](https://github.com/elixir-unicode/unicode_string/actions/workflows/ci.yml/badge.svg)\n[![Hex.pm](https://img.shields.io/hexpm/v/unicode_string.svg)](https://hex.pm/packages/unicode_string)\n[![Hex.pm](https://img.shields.io/hexpm/dw/unicode_string.svg?)](https://hex.pm/packages/unicode_string)\n[![Hex.pm](https://img.shields.io/hexpm/l/unicode_string.svg)](https://hex.pm/packages/unicode_string)\n\nAdds functions supporting some string algorithms in the Unicode standard. For example:\n\n* The [Unicode Case Folding](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) algorithm to provide case-independent equality checking irrespective of language or script with `Unicode.String.fold/2` and `Unicode.String.equals_ignoring_case?/2`\n\n* The [Unicode Code Mapping](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) algorithm that implements locale-aware `Unicode.String.upcase/2`, `Unicode.String.downcase/2` and `Unicode.String.titlecase/2`.\n\n* The [Unicode Segmentation](https://unicode.org/reports/tr29/) algorithm to detect, break, split or stream strings into grapheme clusters, words, sentences and line break points in a locale-aware manner.\n\n* The [Unicode Line Breaking](https://www.unicode.org/reports/tr14/) algorithm to determine line breaks (breaks meaning where word-wrapping would be acceptable).","ref":"readme.html"},{"type":"extras","title":"Casing - Unicode String","doc":"#","ref":"readme.html#casing"},{"type":"extras","title":"Case Folding - Unicode String","doc":"The [Unicode Case Folding](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) algorithm defines how to perform case folding. This allows comparison of strings in a case-insensitive fashion. It does not define the means to compare ignoring diacritical marks (accents). Some examples follow, for details see:\n\n* `Unicode.String.fold/2`\n* `Unicode.String.equals_ignoring_case?/3`\n\n> ##","ref":"readme.html#case-folding"},{"type":"extras","title":"Note {: .info} - Unicode String","doc":">\n> Although the folding algorithm commonly downcases characters, folding is not a general purpose downcasing process. It exists only to facilitate case insensitive string comparison.\n\n\n```elixir\niex> Unicode.String.equals_ignoring_case? \"ABC\", \"abc\"\ntrue\n\niex> Unicode.String.equals_ignoring_case? \"beißen\", \"beissen\"\ntrue\n\niex> Unicode.String.equals_ignoring_case? \"grüßen\", \"grussen\"\nfalse\n```\n\n#","ref":"readme.html#note-info"},{"type":"extras","title":"Case Mapping - Unicode String","doc":"The [Unicode Case Mapping](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) algorithm defines the process and data to transform text into upper case, lower case or title case. Since most languages are not bicameral, characters which have no case mapping remain unchanged.\n\nThree case mapping functions are provided:\n\n* `Unicode.String.upcase/2` which will convert text to upper case characters.\n* `Unicode.String.downcase/2` which will convert text to lower case characters.\n* `Unicode.String.titlecase/2` which will convert text to title case.  Title case means that the first character or each word is set to upper case and all other characters in the word are set to lower case. `Unicode.String.split/2` is used to split the string into words before title casing.\n\nEach function operates in a locale-aware manner implementing some basic capabilities:\n\n* Casing rules for the Turkish dotted capital `I` and dotless small `i`.\n* Casing rules for the retention of dots over `i` for Lithuanian letters with additional accents.\n* Titlecasing of IJ at the start of words in Dutch.\n* Removal of accents when upper casing letters in Greek.\n\nThere are other casing rules that are not currently implemented such as:\n\n* Titlecasing of second or subsequent letters in words in orthographies that include caseless letters such as apostrophes.\n* Uppercasing of U+00DF `ß` latin small letter sharp `s` to U+1E9E `ẞ` latin capital letter sharp `s`.\n\n```elixir\n# Basic case transformation\niex> Unicode.String.upcase(\"the quick brown fox\")\n\"THE QUICK BROWN FOX\"\n\n# Dotted-I in Turkish and Azeri\niex> Unicode.String.upcase(\"Diyarbakır\", locale: :tr)\n\"DİYARBAKIR\"\n\n# Upper case in Greek removes diacritics\niex> Unicode.String.upcase(\"Πατάτα, Αέρας, Μυστήριο\", locale: :el)\n\"ΠΑΤΑΤΑ, ΑΕΡΑΣ, ΜΥΣΤΗΡΙΟ\"\n\n# Lower case Greek with a final sigma\niex> Unicode.String.downcase(\"ὈΔΥΣΣΕΎΣ\", locale: :el)\n\"ὀδυσσεύς\"\n\n# Title case Dutch with leading dipthong\niex> Unicode.String.titlecase(\"ijsselmeer\", locale: :nl)\n\"IJsselmeer\"\n```","ref":"readme.html#case-mapping"},{"type":"extras","title":"Segmentation - Unicode String","doc":"The [Unicode Segmentation](https://unicode.org/reports/tr29/) annex details the algorithm to be applied with segmenting text (Elixir strings) into words, sentences, graphemes and line breaks. Some examples follow, for details see:\n\n* `Unicode.String.split/2`\n* `Unicode.String.break?/2`\n* `Unicode.String.break/2`\n* `Unicode.String.splitter/2`\n* `Unicode.String.next/2`\n* `Unicode.String.stream/2`\n\n```elixir\n# Split text at a word boundary.\niex> Unicode.String.split \"This is a sentence. And another.\", break: :word\n[\"This\", \" \", \"is\", \" \", \"a\", \" \", \"sentence\", \".\", \" \", \"And\", \" \", \"another\", \".\"]\n\n# Split text at a word boundary but omit any whitespace\niex> Unicode.String.split \"This is a sentence. And another.\", break: :word, trim: true\n[\"This\", \"is\", \"a\", \"sentence\", \".\", \"And\", \"another\", \".\"]\n\n# Split text at a sentence boundary.\niex> Unicode.String.split \"This is a sentence. And another.\", break: :sentence\n[\"This is a sentence. \", \"And another.\"]\n\n# By default, common abbreviations are suppressed (ie\n# the do not cause a break)\niex> Unicode.String.split \"No, I don't have a Ph.D. but I don't think it matters.\", break: :word, trim: true\n[\"No\", \",\", \"I\", \"don't\", \"have\", \"a\", \"Ph.D\", \".\", \"but\", \"I\", \"don't\",\n \"think\", \"it\", \"matters\", \".\"]\n\niex> Unicode.String.split \"No, I don't have a Ph.D. but I don't think it matters.\", break: :sentence, trim: true\n[\"No, I don't have a Ph.D. but I don't think it matters.\"]\n\n# Sentence Break suppressions are locale sensitive.\niex> Unicode.String.Segment.known_locales\n[\"de\", \"el\", \"en\", \"en-US\", \"en-US-POSIX\", \"es\", \"fi\", \"fr\", \"it\", \"ja\", \"pt\",\n \"root\", \"ru\", \"sv\", \"zh\", \"zh-Hant\"]\n\niex> Unicode.String.split \"Non, c'est M. Dubois.\", break: :sentence, trim: true, locale: \"fr\"\n[\"Non, c'est M. Dubois.\"]\n\n# Note that break: :line does NOT mean split the string\n# at newlines. It splits the string where a line break would be\n# acceptable. This is very useful for calculating where\n# to perform word-wrap on some text.\niex> Unicode.String.split \"This is a sentence. And another.\", break: :line\n[\"This \", \"is \", \"a \", \"sentence. \", \"And \", \"another.\"]\n```","ref":"readme.html#segmentation"},{"type":"extras","title":"Segment Streaming - Unicode String","doc":"Segmentation can also be streamed using `Unicode.String.stream/2`. For large strings this may improve memory usage since the intermediate segments will be garbage collected when they fall out of scope.\n\n```elixir\niex> Enum.to_list Unicode.String.stream(\"this is a set of words\", trim: true)                       [\"this\", \"is\", \"a\", \"set\", \"of\", \"words\"]\n\niex> Enum.map Unicode.String.stream(\"this is a set of words\", trim: true),\n...>   fn word -> %{word: word, length: String.length(word)} end\n[\n  %{length: 4, word: \"this\"},\n  %{length: 2, word: \"is\"},\n  %{length: 1, word: \"a\"},\n  %{length: 3, word: \"set\"},\n  %{length: 2, word: \"of\"},\n  %{length: 5, word: \"words\"}\n]\n```","ref":"readme.html#segment-streaming"},{"type":"extras","title":"Installation - Unicode String","doc":"The package can be installed by adding `:unicode_string` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:unicode_string, \"~> 1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"References - Unicode String","doc":"* Unicode maintains a [break testing utility](https://util.unicode.org/UnicodeJsps/breaks.jsp).","ref":"readme.html#references"},{"type":"extras","title":"License","doc":"# License\n\nCopyright 2018-2023 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this file except in\ncompliance with the License. You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software distributed under the License\nis distributed on an \"AS IS\" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\nimplied. See the License for the specific language governing permissions and limitations under the\nLicense.","ref":"license.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Unicode String v1.3.1 - Changelog","doc":"This is the changelog for Unicode String v1.3.1 released on March 6th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-3-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix `Unicode.String.split/2` and `Unicode.String.next/2` when the passing rule is `:no_break` rule. Thanks to @GregLMcDonald for the report. Closes #5.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Unicode String v1.3.0 - Changelog","doc":"This is the changelog for Unicode String v1.3.0 released on February 27th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-3-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix case folding for codepoints that fold to themselves.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds case mapping functions `Unicode.String.upcase/2`, `Unicode.String.downcase/2` and `Unicode/String.titlecase/2`. These functions implement the full [Unicode Casing algorithm](https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf) including conditiional mappings. They are locale-aware and a locale can be specified as a string, atom or a [Cldr.LanguageTag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html) thereby providing basic integration between `unicode_string` and [ex_cldr](https://hex.pm/packages/ex_cldr).\n\n* Case folding always follows the `:full` path which allows mapping of single code points to multiple code points. There is no practical reason to implement the `:simple` path. As a result, the `type` parameter to `Unicode.String.Case.Folding.fold/2` is no longer required or supported.\n\n* Support an [ex_cldr](https://hex.pm/packages/ex_cldr) [Language Tag](https://hexdocs.pm/ex_cldr/Cldr.LanguageTag.html) as a parameter to `Unicode.String.Case.Folding.fold/2`. In fact any map that has a `:language` key with a value that is an [ISO 639-1](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes) language code as a lower cased atom may be passed as a parameter.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Unicode String v1.2.1 - Changelog","doc":"This is the changelog for Unicode String v1.2.1 released on June 2nd, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-2-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Resolve segments dir at runtime, not compile time. Thanks to @crkent for the report. Closes #4.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Unicode String v1.2.0 - Changelog","doc":"This is the changelog for Unicode String v1.2.0 released on March 14th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-2-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Unicode.String.stream/2` to support streaming graphemes, words, sentences and line breaks.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Unicode String v1.1.0 - Changelog","doc":"This is the changelog for Unicode String v1.1.0 released on September 21st, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-1-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Updates the segmentation supplemental data (including locales) for CLDR. This adds the \"sv\" and \"fi\" locale data for sentence break suppressions.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Unicode String v1.0.1 - Changelog","doc":"This is the changelog for Unicode String v1.0.1 released on September 15th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-0-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Woops, the priv/segments directory was not included in the build artifact","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Unicode String v1.0.0 - Changelog","doc":"This is the changelog for Unicode String v1.0.0 released on September 14th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v1-0-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Update to use [Unicode 14](https://unicode.org/versions/Unicode14.0.0) release data.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Unicode String v0.3.0 - Changelog","doc":"This is the changelog for Unicode String v0.3.0 released on October 11th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#unicode-string-v0-3-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Correct deps and docs to align with Elixir 1.11 and recent releases of `ex_unicode`.\n\n# Unicode String v0.2.0\n\nThis is the changelog for Unicode String v0.2.0 released on July 12th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"This release implements the Unicode break rules for graphemes, words, lines (word-wrapping) and sentences.\n\n* Adds `Unicode.String.split/2`\n\n* Adds `Unicode.String.break?/2`\n\n* Adds `Unicode.String.break/2`\n\n* Adds `Unicode.String.splitter/2`\n\n* Adds `Unicode.String.next/2`\n\n# Unicode String v0.1.0\n\nThis is the changelog for Unicode String v0.1.0 released on May 17th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-unicode/unicode_string/tags)\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Initial release","ref":"changelog.html#enhancements"}],"content_type":"text/markdown"}